package com.xhkjedu.sapi.controller.appversion;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.xhkjedu.annotation.Action;
import com.xhkjedu.sapi.model.appversion.TAppTeacherapp;
import com.xhkjedu.sapi.service.appversion.AppTeacherappService;
import com.xhkjedu.utils.N_Utils;
import com.xhkjedu.utils.PageUtil;
import com.xhkjedu.vo.PageResult;
import com.xhkjedu.vo.ResultVo;
import com.xhkjedu.sapi.vo.appversion.AppteacherVo;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author ywx
 * @classname AppTeacherappController
 * @description
 * @date 2020/11/27 9:10
 **/
@RestController
@RequestMapping("/appteacher")
public class AppTeacherappController {
    @Resource
    private AppTeacherappService appTeacherappService;

    @PostMapping("/add")
    @Action("教师手机端-增加")
    public ResultVo add(@RequestBody TAppTeacherapp app) {
        N_Utils.validation(new Object[]{app.getVersionname(),"版本名称",2,
                app.getVersioncode(),"版本号",2,app.getVersionpath(),"应用文件",2});
        Integer id = appTeacherappService.save(app);
        return new ResultVo(0, "保存成功",id);
    }

    @PostMapping("/delete")
    @Action("教师手机端-删除")
    public ResultVo delete(@RequestBody TAppTeacherapp app) {
        N_Utils.validation(new Object[]{app.getVersionid(),"版本id",1});
        appTeacherappService.deleteById(app.getVersionid());
        return new ResultVo(0,"删除成功");
    }

    @PostMapping("/update")
    @Action("教师手机端-修改")
    public ResultVo update(@RequestBody TAppTeacherapp app) {
        N_Utils.validation(new Object[]{app.getVersionid(),"版本id",1});
        appTeacherappService.update(app);
        return new ResultVo(0,"修改成功");
    }

    @PostMapping("/detail")
    public ResultVo detail(@RequestBody TAppTeacherapp app) {
        N_Utils.validation(new Object[]{app.getVersionid(),"版本id",1});
        TAppTeacherapp appteacher = appTeacherappService.findById(app.getVersionid());
        return new ResultVo(0,"获取详情成功",appteacher);
    }

    @PostMapping("/list")
    public ResultVo list(@RequestBody TAppTeacherapp app) {
        PageHelper.startPage(app.getPage(), app.getPageSize());
        List<AppteacherVo> list = appTeacherappService.listAll();
        PageResult pageResult = PageUtil.getPageResult(new PageInfo(list));
        return new ResultVo(0,"获取app版本列表成功",pageResult);
    }

    @PostMapping("/get_new")
    public ResultVo getNew() {
        TAppTeacherapp appteacher = appTeacherappService.getNew();
        return new ResultVo(0,"获取最新app版本成功",appteacher);
    }
}
